Attribute VB_Name = "Module1"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

Option Explicit

Private Declare Function CallWindowProc Lib "user32" Alias _
        "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal _
        hwnd As Long, ByVal MSG As Long, ByVal wParam As _
        Long, ByVal lParam As Long) As Long
                
Private Declare Function SetWindowLong Lib "user32" Alias _
        "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex _
        As Long, ByVal dwNewLong As Long) As Long

Private Declare Function GetCursorPos Lib "user32" (lpPoint As _
        POINTAPI) As Long
        
Private Declare Function GetSystemMetrics Lib "user32" (ByVal _
        nIndex As Long) As Long

Public Type POINTAPI
  x As Long
  y As Long
End Type
 
Const SM_CXFRAME = 32
Const SM_CYFRAME = 33
Const SM_CYCAPTION = 4
 
Const WM_NCRBUTTONDOWN = &HA4
Const WM_NCLBUTTONDOWN = &HA1

Const GWL_WNDPROC = (-4&)

Dim PrevWndProc&

Private Function SubWndProc(ByVal hwnd As Long, ByVal MSG As Long, _
                            ByVal wParam As Long, ByVal lParam As _
                            Long) As Long
                              
  If Form1.WindowState <> vbMinimized Then
    If MSG = WM_NCLBUTTONDOWN Then
      If IsOverIcon Then
        SubWndProc = 0
        Exit Function
      End If
    ElseIf MSG = WM_NCRBUTTONDOWN Then
      SubWndProc = 0
      Exit Function
    End If
  End If
  SubWndProc = CallWindowProc(PrevWndProc, hwnd, MSG, wParam, lParam)
End Function

Public Sub Init(hwnd&)
  PrevWndProc = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf SubWndProc)
End Sub

Public Sub Terminate(hwnd&)
  Call SetWindowLong(hwnd, GWL_WNDPROC, PrevWndProc)
End Sub

Public Function IsOverIcon() As Boolean
  Dim Result&, P As POINTAPI
  Dim FrameX&, FrameY&, TitleY&, FLeft&, FTop&
  
    Result = GetCursorPos(P)
    FLeft = Form1.ScaleX(Form1.Left, vbTwips, vbPixels)
    FTop = Form1.ScaleX(Form1.Top, vbTwips, vbPixels)
    FrameX = GetSystemMetrics(SM_CXFRAME) - 1
    FrameY = GetSystemMetrics(SM_CYFRAME) - 1
    TitleY = GetSystemMetrics(SM_CYCAPTION)
    
    If P.x > FLeft + FrameX And P.y > FTop + FrameY Then
      If P.y < FTop + FrameY + TitleY And _
         P.x < FLeft + FrameX + TitleY Then IsOverIcon = True
    End If
End Function
